#include-once
#include <WindowsConstants.au3>
#include <GUIConstantsEx.au3>
#include <Misc.au3>
#include "_GUIRegisterMsg.au3"

Opt("MustDeclareVars", 1)

Global $SOH_PrevHover				= 0
Global $SOH_ClicInit				= 0
Global $SOH_CallsBack[1][5]			= [[0, "", "", "", ""]]
Global $__GUICtrl_SOH_User32_Dll	= DllOpen("User32.dll")

_GUIRegisterMsg($WM_SETCURSOR, "__SOH_WM_COMMAND")

Func _GuiCtrlSetOnHover($CtrlId, $HoverIn = "", $HoverOut = "", $ClicIn = "", $ClicRelease = "")
	If($HoverIn = "" And $HoverOut = "" And $ClicIn = "" And $ClicRelease = "") Then
		_GuiCtrlUnsetOnHover($CtrlId)
	Else
		Local $NumeroItem = __GetItemByCtrlId(GUICtrlGetHandle($CtrlId))
		If($NumeroItem < 0) Then
			$NumeroItem = UBound($SOH_CallsBack, 1)-1
			ReDim $SOH_CallsBack[UBound($SOH_CallsBack, 1)+1][UBound($SOH_CallsBack, 2)]
		EndIf
		$SOH_CallsBack[$NumeroItem][0] = $CtrlId
		$SOH_CallsBack[$NumeroItem][1] = $HoverIn
		$SOH_CallsBack[$NumeroItem][2] = $HoverOut
		$SOH_CallsBack[$NumeroItem][3] = $ClicIn
		$SOH_CallsBack[$NumeroItem][4] = $ClicRelease
	EndIf
EndFunc

Func _GuiCtrlUnsetOnHover($CtrlId)
	Local $NumeroItem = __GetItemByCtrlId(GUICtrlGetHandle($CtrlId))
	If($NumeroItem >= 0) Then
		For $i = $NumeroItem To UBound($SOH_CallsBack, 1)-2
			For $j = 0 To UBound($SOH_CallsBack, 2)-1
				$SOH_CallsBack[$i][$j] = $SOH_CallsBack[$i+1][$j]
			Next
		Next
		ReDim $SOH_CallsBack[UBound($SOH_CallsBack, 1)-1][UBound($SOH_CallsBack, 2)]
	EndIf
EndFunc

Func __GetItemByCtrlId($CtrlId)
	Local $Id = -1
	For $i = 0 To UBound($SOH_CallsBack, 1)-2
		If(GUICtrlGetHandle($SOH_CallsBack[$i][0]) = $CtrlId) Then
			$Id = $i
			ExitLoop
		EndIf
	Next
	Return $Id
EndFunc

Func __SOH_WM_COMMAND($hWndGUI, $MsgID, $WParam, $LParam)
	Local $CtrlHover = __GUICtrl_SOH_ControlGetHovered()
	Local $IsClicked = _IsPressed("01")
	If(Not($IsClicked = $SOH_ClicInit)) Then
		Local $NumeroHover = __GetItemByCtrlId($CtrlHover)
		If($IsClicked And Not($SOH_ClicInit)) Then
			$SOH_ClicInit = $CtrlHover
			If($NumeroHover >= 0) Then
				Call($SOH_CallsBack[$NumeroHover][3], $SOH_CallsBack[$NumeroHover][0], 3, True)
			EndIf
		ElseIf(Not($IsClicked) And $SOH_ClicInit) Then
			Local $NumeroClicked = __GetItemByCtrlId($SOH_ClicInit)
			$SOH_ClicInit = 0
			If($NumeroClicked >= 0) Then
				Local $IsMe = $NumeroHover = $NumeroClicked
				Call($SOH_CallsBack[$NumeroClicked][4], $SOH_CallsBack[$NumeroClicked][0], 4, $IsMe)
			EndIf
		EndIf
	ElseIf($CtrlHover <> $SOH_PrevHover) Then
		Local $Ctrls[2][2] = [[$SOH_PrevHover, 2], [$CtrlHover, 1]]
		For $i = 0 To UBound($Ctrls, 1)-1
			Local $Numero = __GetItemByCtrlId($Ctrls[$i][0])
			If($Numero >= 0) Then
				If($SOH_CallsBack[$Numero][$Ctrls[$i][1]] <> "") Then
					If($IsClicked) Then
						Local $IsMe = $Ctrls[$i][0] = $SOH_ClicInit
						If($i = 1) Then
							Call($SOH_CallsBack[$Numero][3], $SOH_CallsBack[$Numero][0], 3, $IsMe)
						Else
							Call($SOH_CallsBack[$Numero][$Ctrls[$i][1]], $SOH_CallsBack[$Numero][0], $Ctrls[$i][1], $IsMe)
						EndIf
					Else
						Call($SOH_CallsBack[$Numero][$Ctrls[$i][1]], $SOH_CallsBack[$Numero][0], $Ctrls[$i][1], True)
					EndIf
				EndIf
			EndIf
		Next
		$SOH_PrevHover = $CtrlHover
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc

Func __GUICtrl_SOH_ControlGetHovered()
	Local $iOld_Opt_MCM = Opt("MouseCoordMode", 1)
	Local $tPoint = DllStructCreate("int X;int Y")
	Local $aMPos = MouseGetPos()

	DllStructSetData($tPoint, "x", $aMPos[0])
	DllStructSetData($tPoint, "y", $aMPos[1])

	Local $tPointCast = DllStructCreate("int64", DllStructGetPtr($tPoint))
	Local $aRet = DllCall($__GUICtrl_SOH_User32_Dll, "hwnd", "WindowFromPoint", "int64", DllStructGetData($tPointCast, 1))

	Opt("MouseCoordMode", $iOld_Opt_MCM)

	If @error Then
		Return SetError(@error, @extended, 0)
	EndIf

	Return $aRet[0]
EndFunc