#include-once
#include <GUIConstantsEx.au3>

Global $UDF_GUIRegisterMsg[1][2]
Global $UDF_ListeRegisters[1]

Func _GUIRegisterMsg($Msg, $Fonction)
	;Si la fonctoin n'a pas encore t register pour le message donn
	If(__GUIRegisterGetRegister($Msg, $Fonction) = -1) Then
		;On ajoute la fonction et le message dans la liste
		__GUIRegisterAddMsg($Msg)
		Local $NumeroRegister = UBound($UDF_GUIRegisterMsg, 1)-1
		$UDF_GUIRegisterMsg[$NumeroRegister][0] = $Msg
		$UDF_GUIRegisterMsg[$NumeroRegister][1] = $Fonction
		ReDim $UDF_GUIRegisterMsg[UBound($UDF_GUIRegisterMsg, 1)+1][UBound($UDF_GUIRegisterMsg, 2)]
	EndIf
EndFunc

Func _GUIUnRegisterMsg($Msg, $Fonction)
	Local $Numero = __GUIRegisterGetRegister($Msg, $Fonction)
	; Si la fonction associe au message existe
	If($Numero >= 0) Then
		; On la supprime de la liste
		__GUIRegisterDelRegister($Numero)
	EndIf
EndFunc

Func __GUIRegisterAddMsg($Msg)
	Local $IDMsg = -1
	; On cherche si le message  dj t register
	For $i = 0 To UBound($UDF_ListeRegisters, 1)-2
		If($UDF_ListeRegisters[$i] = $Msg) Then
			$IDMsg = $i
			ExitLoop
		EndIf
	Next
	; Si le message n'a pas encore t register
	If($IDMsg = -1) Then
		$UDF_ListeRegisters[UBound($UDF_ListeRegisters, 1)-1] = $Msg
		GUIRegisterMsg($Msg, "__Func_GUIRegisterMsg")
	EndIf
EndFunc

Func __Func_GUIRegisterMsg($hWnd, $Msg, $wParam, $lParam)
;~ 	ConsoleWrite("Hehe : " & $hWnd & ", " & $Msg & ", " & $wParam & ", " & $lParam & @CRLF)
	Local $Return = $GUI_RUNDEFMSG
	Local $ReturnBis
	For $i = 0 To UBound($UDF_GUIRegisterMsg, 1)-2
		If($UDF_GUIRegisterMsg[$i][0] = $Msg) Then
			$ReturnBis = Call($UDF_GUIRegisterMsg[$i][1], $hWnd, $Msg, $wParam, $lParam)
			If($ReturnBis <> $GUI_RUNDEFMSG) Then
				$Return = $ReturnBis
			EndIf
		EndIf
	Next
	Return $Return
EndFunc

Func __GUIRegisterGetRegister($Msg, $Fonction)
	Local $Retour = -1
	For $i = 0 To UBound($UDF_GUIRegisterMsg, 1)-2
		If($UDF_GUIRegisterMsg[$i][0] = $Msg And $UDF_GUIRegisterMsg[$i][1] = $Fonction) Then
			$Retour = $i
			ExitLoop
		EndIf
	Next
	Return $Retour
EndFunc

Func __GUIRegisterDelRegister($Numero)
	For $i = $Numero To UBound($UDF_GUIRegisterMsg, 1)-3
		$UDF_GUIRegisterMsg[$i][0] = $UDF_GUIRegisterMsg[$i+1][0]
		$UDF_GUIRegisterMsg[$i][1] = $UDF_GUIRegisterMsg[$i+1][1]
	Next
	ReDim $UDF_GUIRegisterMsg[UBound($UDF_GUIRegisterMsg, 1)-1][UBound($UDF_GUIRegisterMsg, 2)]
EndFunc
